| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Attributes | List of all members
IG.Script.AppBase Class Reference

Base cls. for application scripts that can also be used on its own. More...

Inheritance diagram for IG.Script.AppBase:
[legend]
Collaboration diagram for IG.Script.AppBase:
[legend]

## Public Member Functions
| AppBase ()
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
virtual string | AppCustom (string[] arguments)
| Runs one of the custom embedded applications. More...
Public Member Functions inherited from IG.Script.ScriptAppBase
void | Script_AddCommands1 (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
| ScriptAppBase ()
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
virtual string | RunFileByScript (string filePath)
| Runs all commands that are written in a file. Each line of a file is interpreted as a single command, consisting of command name followed by arguments. More...
virtual void | ReportError (string errorString)
new string | AppMyTest (string[] arguments)
| Test action. More...
override string | AppCustomApp (string[] arguments)
| Custom application. More...
virtual string | AppNumerics (string[] arguments)
| Runs one of the numerics - related embedded applications. More...
virtual string | AppFile (string[] arguments)
| Runs one of the file system - related embedded applications. More...
virtual string | AppCrypto (string[] arguments)
| Runs one of the cryptography - related embedded applications. More...
virtual string | AppSystem (string[] arguments)
| Runs one of the file system - related embedded applications. More...
virtual string | AppAssembly (string[] arguments)
| Runs one of the file assembly - related embedded applications. More...
virtual string | AppProcess (string[] arguments)
| Runs one of the process - related embedded applications. More...
virtual string | AppDataStructures (string[] arguments)
| Runs one of the data structures demo - related embedded applications. More...
Public Member Functions inherited from IG.Script.LoadableScriptSpecialFunctionBase
| LoadableScriptSpecialFunctionBase ()
override void | Script_AddCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings, string commandName, Script_CommandDelegate command, string helpString)
| Adds a new internal script command under specified name to the internal interpreter of the current script object. More...
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
string | AppMyTest (string[] arguments)
| Test action. More...
Public Member Functions inherited from IG.Lib.LoadableScriptBase
| LoadableScriptBase ()
| Argument-less constructor. If argument-less constructor is called then initialization is not performed and will be performed later. More...
string | Run (string[] arguments)
| Performs the action of this object. Override this in derived classes! More...
void | Initialize (string[] arguments)
| Initializes the object. If not called explicitly, this method is automatically called at the first call to the Run method. More...
virtual string | Script_DefaultInitialize (string[] arguments)
| Default initialization method for scripts. More...
virtual string | Script_DefaultRun (string[] arguments)
| Default run method for the script. Can be used when only installed commands are run by hte script. More...
virtual ICommandLineApplicationInterpreter | Script_CreateInterpreterWithoutCommands ()
| Creates and returns an interpreter that can be used as script's internal interpreter for running script's commands. More...
delegate string | Script_CommandDelegate (string[] args)
| Delegate for commands that are installed on script's internal interpreter (property Script_Interpreter). More...
void | Script_AddCommand (string commandName, Script_CommandDelegate command, string helpString)
| Adds a new internal script command under specified name to the internal interpreter of the current script object. More...
string | Script_GetHelpString (string scriptCommandName)
| Returns help string for internal script command with specified name, or null if help string is not installed for such a command. More...
void | Script_PrintCommandsHelp ()
| Prits help for the installed internal commands of the script. More...
virtual bool | Script_ContainsCommand (string commandName)
| Returns true if the internal script's interpreter contains a command with specified name, false otherwise. More...
virtual bool | Script_ContainsScriptCommand (string commandName)
| Returns true if the specified command is script command (i.e. its first argument is command-name and it is run through the Script_CommandAdapter object). More...
virtual void | Script_RemoveCommand (string commandName)
| Removes the specified internal script command from the internal interpreter of the current scripting object. More...
virtual void | Script_RemoveAllCommands ()
| Removes ALL internal script commands from the internal interpreter of the current scripting object. More...
string | Script_Run (string[] arguments)
| Runs internal script command. More...
string | Script_Run (string commandName, params string[] otherArguments)
| Runs internal script command. More...
virtual void | Script_PrintArguments (string messageString, string[] arguments)
| Prints the specified array of string arguments (usually passed as command-line arguments). More...

## Public Attributes
const string | ConstCustom = "Custom"
| Name of the command for a group of custom applications. More...
const string | ConstHelpCustom = "Custom application group."
const string | FileTestArguments = "PrintArguments"
const string | CustomPrintArguments = "PrintArguments"
Public Attributes inherited from IG.Script.ScriptAppBase
const string | DataStructuresTestCsvApp = "TestCsv"
const string | DataStructuresTestCsvWriteDefinitionAndData = "CsvWriteDefinitionAndData"
const string | DataStructuresTestCsvReadDefinitionAndData = "CsvReadDefinitionAndData"
new const string | ConstMyTest = "MyTest"
| Name of the command that performs my custom test. More...
new const string | ConstHelpMyTest = "Custom test function."
new const string | ConstCustomApp = "CustomApp"
| Name of the command for custom test. More...
new const string | ConstHelpCustomApp = "Custom aplication."
const string | ConstSystem = "System"
| Name of the command for the system-related embedded applications. More...
const string | ConstHelpSystem = "Various system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstAssembly = "Assembly"
| Name of the command for the assemblies-related embedded applications. More...
const string | ConstHelpAssembly = "Various assemblies-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstNumerics = "Numerics"
| Name of the command for the numerics-related embedded applications. More...
const string | ConstHelpNumerics = "Various numerics-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstFile = "File"
| Name of the command for the file system-related embedded applications. More...
const string | ConstHelpFile = "Various file system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstCrypto1 = "Crypto"
| Name of the command for the cryptography-related embedded applications. More...
const string | ConstHelpCrypto = "Various cryptography-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstProcess = "Process"
| Name of the command for the process-related embedded applications. More...
const string | ConstHelpProcess = "Various process-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstDataStructures = "DataStructures"
| Name of the command for the data structures-related embedded applications. More...
const string | ConstHelpDataStructures
const string | ConstRunFile = "RunFileByScript"
| Name of the command that runs (interprets) the specified command file by the script's interpreter. More...
const string | ConstHelpRunFile
const string | NumericsScriptScalarFunction = "ScriptScalarFunction"
const string | FileLogEvents = "LogEvents"
const string | FileWaitCreation = "WaitCreation"
const string | FileRelativePath = "RelativePath"
const string | FileStandardPath = "StandardPath"
const string | FileCurrentDirectory = "CurrentDirectory"
const string | FileCurrentDirectory1 = "SetCurrentDirectory"
const string | CryptoGetFileHash = "GetFileHash"
const string | CryptoCheckSum = "CheckSum"
const string | CryptoEncryptBasic = "EncryptBasic"
const string | CryptoDecryptBasic = "DecryptBasic"
const string | CryptoEncryptPlain = "EncryptPlain"
const string | CryptoDecryptPlain = "DecryptPlain"
const string | CryptoGetKey = "GetKey"
const string | CryptoGetInitializationVector = "GetInitializationVector"
const string | CryptoGetInitializationVector1 = "GetIV"
const string | CryptoGetSalt = "GetSalt"
const string | CryptoTimeKeyGeneration = "TimeKeyGeneration"
const string | CryptoConvert = "Convert"
const string | CryptoAsymKeyInfo = "AsymKeyInfo"
const string | CryptoCertStoreInfo = "CertStoreInfo"
const string | CryptoCertInfo = "CertInfo"
const string | CryptoAddCertificate = "AddCertificate"
const string | CryptoRemoveCertificate = "RemoveCertificate"
const string | CryptoAsymTest = "AsymTest"
const string | CryptoCleanFiles = "CleanFiles"
const string | SystemRuntimeVersion = "RuntimeVersion"
const string | SystemComputerName = "ComputerName"
const string | SystemDomainName = "DomainName"
const string | SystemIpAddress = "IpAddress"
const string | SystemUserName = "UserName"
const string | SystemSystemInfo = "Info"
const string | SystemMACAddress = "MACAddress"
const string | AssemblyInfo = "Info"
const string | AssemblyInfo1 = "AssemblyInfo"
const string | AssemblyResources = "Resources"
const string | AssemblyResources1 = "ResourceInfo"
const string | AssemblyResourcesEmbedded = "ResourcesEmbedded"
const string | AssemblyResourcesResx = "ResourcesResx"
const string | AssemblyReferenced = "ReferencedAssemblies"
const string | AssemblyReferenced1 = "Referenced"
const string | AssemblyLoaded = "LoadedAssemblies"
const string | AssemblyLoaded1 = "Loaded"
const string | AssemblyLoad = "LoadAssemblies"
const string | AssemblyLoad1 = "Load"
const string | AssemblyInfoLoad = "InfoLoadAssemblies"
const string | AssemblyInfoLoad1 = "InfoLoad"
const string | ProcessListProcesses = "ListProcesses"
const string | ProcessListApplications = "ListApplications"
const string | ProcessListApplicationsByWindow = "ListApplicationsByWindow"
const string | ProcessKillProcesses = "KillProcesses"
const string | ProcessKillApplications = "KillApplications"
const string | ProcessKillApplicationsByWindow = "KillApplicationsByWindow"
Public Attributes inherited from IG.Script.LoadableScriptSpecialFunctionBase
const string | ConstMyTest = "MyTest"
| Name of the command that performs my custom test. More...
const string | ConstHelpMyTest = "Custom test function."
const string | ConstCustomApp = "CustomApp"
| Name of the command for custom test. More...
const string | ConstHelpCustomApp = "Custom aplication."
Public Attributes inherited from IG.Lib.LoadableScriptBase
const string | ConstDefaultHelp = "Help"
| Default command name for help. More...
const string | ConstHelpDefaultUniversal = "?"
| Universal name of the help command. More...
const string | ConstDefaultTestScrip = "TestScript"
| Default command name for test method. More...

## Protected Member Functions
override void | InitAppFile ()
| Initializes commands for file system related utilities (embedded applications). More...
virtual string | FileFunctionTestArguments (string appName, string[] args)
| Executes embedded application that just prints arguments passed to the application to a console. More...
void | AddCustomCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new file system - related embedded application's command (added as sub-command of the base command named ScriptAppBase.ConstFile). More...
virtual string | CustomFunctionPrintArguments (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual void | InitAppCustom ()
| Initializes commands for file system related utilities (embedded applications). More...
virtual string | RunAppCustom (string[] args)
| Runs a file system related utility (embedded application) according to arguments. More...
Protected Member Functions inherited from IG.Script.ScriptAppBase
virtual void | InitAppDataStructuresPartial ()
| Initializes commands for form demo related utilities (embedded applications). More...
virtual string | DataStructuresFunctionTestCsvApp (string appName, string[] args)
| Executes embedded application - demo application for demonstration of work with CSVs. More...
virtual string | DataStructuresFunctionTestCsvWriteDefinitionAndData (string appName, string[] args)
| Executes embedded application - test of writing sampled data definition and data in CSV format. More...
virtual string | DataStructuresFunctionTestCsvReadDefinitionAndData (string appName, string[] appArgs)
| Executes embedded application - test of writing sampled data definition and data in CSV format. More...
override void | InitializeThis (string[] arguments)
| Initializes the current object. More...
override string | RunThis (string[] arguments)
| Runs action of the current object. More...
void | Script_AddRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds the Run comand to the script's interpreter and performs the necessary additional tasks. More...
void | Script_RemoveRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Removes the Run comand from the script's interpreter and performs the necessary accompanying tasks. More...
virtual string | AppRunFileByScript (string[] args)
| Execution method that Runs the specified command file by the script's interpreter. More...
void | AddNumericsCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new numerics - related embedded application's command (added as sub-command of the base command named ConstNumerics). More...
virtual string | NumericsFunctionScriptScalarFuncitons (string appName, string[] args)
| Executes embedded application - testing of definition of scalar function objects through expressions. More...
virtual void | InitAppNumerics ()
| Initializes commands for numerics related utilities (embedded applications). More...
virtual string | RunAppNumerics (string[] args)
| Runs a numerics related utility (embedded application) according to arguments. More...
void | AddFileCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new file system - related embedded application's command (added as sub-command of the base command named ConstFile). More...
virtual string | FileFunctionLogEvents (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionWaitCreation (string appName, string[] args)
| Executes embedded application - waiting for creation of the specified file. More...
virtual string | FileFunctionRelativePath (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionStandardPath (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionCurrentDirectory (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | RunAppFile (string[] args)
| Runs a file system related utility (embedded application) according to arguments. More...
void | AddCryptoCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new cryptography - related embedded application's command (added as sub-command of the base command named ConstCrypto1). More...
virtual string | CryptoFunctionGetFileHash (string appName, string[] args)
| Executes embedded application - calculation of various hashRet values of a file. More...
virtual string | CryptoFunctionCheckSum (string appName, string[] args)
| Executes embedded application - calculation AND verification of various hashRet values of a file or a string. More...
virtual string | CryptoFunctionEncryptBasic (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields by using the BASIC class of methods. More...
virtual string | CryptoFunctionDecryptBasic (string appName, string[] args)
| Executes embedded application - symmetric decryption of files, strings, or byte fields by using the BASIC class of methods. More...
virtual string | CryptoFunctionEncryptPlain (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields by using the PLAIN class of methods. More...
virtual string | CryptoFunctionDecryptPlain (string appName, string[] args)
| Executes embedded application - symmetric decryption of files, strings, or byte fields by using the PLAIN class of methods. More...
virtual string | CryptoFunctionGetKey (string appName, string[] args)
| Executes embedded application - generation of secret keys for encryption. More...
virtual string | CryptoFunctionGetInitializationVector (string appName, string[] args)
| Executes embedded application - generation of initialization vectors for encryption. More...
virtual string | CryptoFunctionGetSalt (string appName, string[] args)
| Executes embedded application - generation of salts for encryption. More...
virtual string | CryptoFunctionTimeKeyGeneration (string appName, string[] args)
| Executes embedded application - measuring time of password generaton utilities. More...
virtual string | CryptoFunctionConvert (string appName, string[] args)
| Executes embedded application - conversion between different representations of data. More...
virtual string | CryptoFunctionAsymKeyInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified asymmetric key. More...
virtual string | CryptoFunctionCertStoreInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified certificate store. More...
virtual string | CryptoFunctionCertInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified certificate. More...
virtual string | CryptoFunctionAddCertificate (string appName, string[] args)
| Executes embedded application - adding the specified certificate to the specified certificate store. More...
virtual string | CryptoFunctionRemoveCertificate (string appName, string[] args)
| Executes embedded application - removing the certificate from certificate store. More...
virtual string | CryptoFunctionAsymTest (string appName, string[] args)
| Executes embedded application - test of asymmetric encrypton. More...
virtual string | CryptoFunctionCleanFiles (string appName, string[] args)
| Executes embedded application - conversion between different representations of data. More...
virtual void | InitAppCrypto ()
| Initializes commands for cryptography related utilities (embedded applications). More...
virtual string | RunAppCrypto (string[] args)
| Runs a cryptography related utility (embedded application) according to arguments. More...
virtual string | CryptoFunctionGetFileHash_OLD_TO_DELETE (string appName, string[] args)
| Executes embedded application - calculation of various hashRet values of a file. More...
virtual string | CryptoFunctionCheckSum_OLD_TO_DELETE_LATER (string appName, string[] args)
| Executes embedded application - calculation AND verification of various hashRet values of a file. More...
virtual string | CryptoFunctionTimeKeyGeneration_OLD_TO_DELETE_LATER (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields. More...
virtual string | CryptoFunctionConvert_OLD_TO_DELETE (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields. More...
void | AddSystemCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new system - related embedded application's command (added as sub-command of the base command named ConstSystem). More...
virtual string | SystemFunctionRuntimeVersion (string appName, string[] args)
| Executes embedded application - writing to the console and returning version of the runtime that application runs on. More...
virtual string | SystemFunctionComputerName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current computer name. More...
virtual string | SystemFunctionDomainName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name. More...
virtual string | SystemFunctionIpAddress (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current IP address. More...
virtual string | SystemFunctionUserName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current user name. More...
virtual string | SystemFunctionSystemInfo (string appName, string[] args)
| Executes embedded application - writing to the console and returning the system info. More...
virtual string | SystemFunctionMACAddress (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name. More...
virtual void | InitAppSystem ()
| Initializes commands for file system related utilities (embedded applications). More...
virtual string | RunAppSystem (string[] args)
| Runs a file system related utility (embedded application) according to arguments. More...
void | AddAssemblyCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new assembly - related embedded application's command (added as sub-command of the base command named ConstSystem). More...
virtual string | AssemblyFunctionInfo (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly. More...
virtual string | AssemblyFunctionResourcesEmbedded (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's embedded resources. More...
virtual string | AssemblyFunctionResourcesResx (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's resources included through .resx files. More...
virtual string | AssemblyFunctionResources (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's resources. More...
virtual string | AssemblyFunctionResources (string appName, string[] args, bool includeEmbedded, bool includeResx)
| Executes embedded application - writing to the console information about the specified assembly's resources. More...
virtual string | AssemblyFunctionReferenced (string appName, string[] args)
| Executes embedded application - writing to the console list of referenced assemblies. More...
virtual string | AssemblyFunctionLoaded (string appName, string[] args)
| Executes embedded application - writing to the console list of loaded assemblies. More...
virtual string | AssemblyFunctionLoadAssemblies (string appName, string[] args)
| Executes embedded application - loading the specified assemblies to the application domain. More...
virtual string | AssemblyFunctionInfoLoadAssemblies (string appName, string[] args)
| Executes embedded application - loading the specified assemblies for inspection only (can not be executed). More...
virtual string | AssemblyFunctionLoadAssemblies (int outputLevel, bool reflectionOnly, string appName, string[] args)
| Executes embedded application - loading the specified assemblies to the application domain. More...
virtual void | InitAppAssembly ()
| Initializes commands for assembly related utilities (embedded applications). More...
virtual string | RunAppAssembly (string[] args)
| Runs a file assembly related utility (embedded application) according to arguments. More...
void | AddProcessCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new process - related embedded application's command (added as sub-command of the base command named ConstProcess). More...
virtual string | ProcessFunctionListProcesses (string appName, string[] args)
| Embedded application - lists all processes that satisfy the specified conditions. More...
virtual string | ProcessFunctionListApplications (string appName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionListApplicationsByWindow (string appName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionKillProcesses (string appName, string[] args)
| Embedded application - kills all processes that satisfy the specified conditions. More...
virtual string | ProcessFunctionKillApplications (string appName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionKillApplicationsByWindow (string appName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions. More...
virtual void | InitAppProcess ()
| Initializes commands for process - related utilities (embedded applications). More...
virtual string | RunAppProcess (string[] args)
| Runs a process - related utility (embedded application) according to arguments. More...
void | AddDataStructuresCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new data structure- related embedded demo application's command (added as a sub-command of the base command named ConstDataStructures). More...
virtual void | InitAppDataStructures ()
| Initializes commands for form demo related utilities (embedded applications). More...
virtual string | RunAppDataStructures (string[] args)
| Runs a data structures demo - related utility (embedded application) according to arguments. More...
Protected Member Functions inherited from IG.Script.LoadableScriptSpecialFunctionBase
override void | InitializeThis (string[] arguments)
| Initializes the current object. More...
override string | RunThis (string[] arguments)
| Runs action of the current object. More...
Protected Member Functions inherited from IG.Lib.LoadableScriptBase
delegate string | CommandMethod (string commandName, string[] args)
| Delegate for internal command methods. More...
ICommandLineApplicationInterpreter | Script_CreateInterpreter ()
| Creates and returns an interpreter that can be used as script's internal interpreter for running script's commands. More...
virtual string | Script_CommandHelp (string[] arguments)
| Prints help. More...
virtual string | Script_CommandTestScript (string[] arguments)
| Prints help. More...

## Protected Attributes
List< string > | AppCustomNames = new List<string>()
| List of installed file command names. More...
List< string > | AppCustomHelpStrings = new List<string>()
| List of help strings corresponding to installed file commands. More...
List< CommandMethod > | AppCustomMethods = new List<CommandMethod>()
| List of methods used to perform file commmands. More...
const string | CustomHelpPrintArguments = CustomPrintArguments + " arg1 arg2 ... : Prints out the arguments of the command."
bool | _appCustomCommandsInitialized = false
Protected Attributes inherited from IG.Script.ScriptAppBase
const string | DataStructuresHelpTestCsvApp = DataStructuresTestCsvApp + " : Runs the CSV simple demo application."
const string | DataStructuresHelpTestCsvWriteDefinitionAndData
const string | DataStructuresHelpTestCsvReadDefinitionAndData
bool | _isAddRunFileByScriptCommand = true
List< string > | AppNumericsNames = new List<string>()
| List of installed numerics command names. More...
List< string > | AppNumericsHelpStrings = new List<string>()
| List of help strings corresponding to installed numerics-related commands. More...
List< CommandMethod > | AppNumericsMethods = new List<CommandMethod>()
| List of methods used to perform numerics-related commmands. More...
const string | NumericsHelpScriptScalarFunction = NumericsScriptScalarFunction + " : Definition of scalar functions by expressions."
bool | _appNumericsCommandsInitialized = false
List< string > | AppFileNames = new List<string>()
| List of installed file command names. More...
List< string > | AppFileHelpStrings = new List<string>()
| List of help strings corresponding to installed file commands. More...
List< CommandMethod > | AppFileMethods = new List<CommandMethod>()
| List of methods used to perform file commmands. More...
const string | FileHelpLogEvents = FileLogEvents + " FileOrDirectory MaxEvents : Logs file events for the specified file or directory."
const string | FileHelpWaitCreation = NumericsScriptScalarFunction + " FilePath <ReturnIfExists> : Waits until file is created."
const string | FileHelpRelativePath
const string | FileHelpStandardPath
const string | FileHelpCurrentDirectory
const string | FileHelpCurrentDirectory1
bool | _appFileCommandsInitialized = false
List< string > | AppCryptoNames = new List<string>()
| List of installed cryptographic command names. More...
List< string > | AppCryptoHelpStrings = new List<string>()
| List of help strings corresponding to installed cryptographic commands. More...
List< CommandMethod > | AppCryptoMethods = new List<CommandMethod>()
| List of methods used to perform cryptographic commmands. More...
const string | CryptoHelpGetFileHash
const string | CryptoHelpCheckSum
const string | CryptoHelpDecryptBasic = CryptoDecryptBasic + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptBasic = CryptoEncryptBasic + CryptoHelpEncryptBasicPart
const string | CryptoHelpDecryptPlain = CryptoDecryptPlain + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptPlain = CryptoEncryptPlain + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptBasicPart
const string | CryptoHelpGetKey = CryptoGetKey + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetInitializationVector = CryptoGetInitializationVector + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetInitializationVector1 = CryptoGetInitializationVector1 + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetSalt = CryptoGetSalt + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetKeyLastPart
const string | CryptoHelpTimeKeyGeneration
const string | CryptoHelpConvert
const string | CryptoHelpAsymKeyInfo
const string | CryptoHelpCertStoreInfo
const string | CryptoHelpCertInfo
const string | CryptoHelpAddCertificate
const string | CryptoHelpRemoveCertificate
const string | CryptoHelpAsymTest
const string | CryptoHelpCleanFiles
bool | _appCryptoCommandsInitialized = false
List< string > | AppSystemNames = new List<string>()
| List of installed system related command names. More...
List< string > | AppSystemHelpStrings = new List<string>()
| List of help strings corresponding to installed system related commands. More...
List< CommandMethod > | AppSystemMethods = new List<CommandMethod>()
| List of methods used to perform system related commmands. More...
const string | SystemHelpRuntimeVersion = SystemRuntimeVersion + " : Prints version of the runtime environment that application runs on."
const string | SystemHelpComputerName = SystemComputerName + " : Prints and returns the current computer name."
const string | SystemHelpDomainName = SystemDomainName + " : Prints and returns the current domain name."
const string | SystemHelpIpAddress = SystemIpAddress + " : Prints and returns IP address of the current computer."
const string | SystemHelpUserName = SystemUserName + " : Prints and returns the current user name."
const string | SystemHelpSystemInfo = SystemSystemInfo + " : Prints and returns basic system info."
const string | SystemHelpMACAddress = SystemMACAddress + " : Prints and returns the current domain name."
bool | _appSystemCommandsInitialized = false
List< string > | AppAssemblyNames = new List<string>()
| List of installed assemblies related command names. More...
List< string > | AppAssemblyHelpStrings = new List<string>()
| List of help strings corresponding to installed assembly related commands. More...
List< CommandMethod > | AppAssemblyMethods = new List<CommandMethod>()
| List of methods used to perform assembly related commmands. More...
const string | AssemblyHelpInfo
const string | AssemblyHelpInfo1
const string | AssemblyHelpResources
const string | AssemblyHelpResources1
const string | AssemblyHelpResourcesEmbedded
const string | AssemblyHelpResourcesResx
const string | AssemblyHelpReferenced
const string | AssemblyHelpReferenced1 = AssemblyHelpReferenced
const string | AssemblyHelpLoaded = AssemblyLoaded + @" : Prints all loaded assemblies."
const string | AssemblyHelpLoaded1 = AssemblyHelpLoaded
const string | AssemblyHelpLoad
const string | AssemblyHelpLoad1 = AssemblyHelpLoad
const string | AssemblyHelpInfoLoad
const string | AssemblyHelpInfoLoad1 = AssemblyHelpInfoLoad
bool | _appAssemblyCommandsInitialized = false
List< string > | AppProcessNames = new List<string>()
| List of installed process-related command names. More...
List< string > | AppProcessHelpStrings = new List<string>()
| List of help strings corresponding to installed process commands. More...
List< CommandMethod > | AppProcessMethods = new List<CommandMethod>()
| List of methods used to perform process-related commmands. More...
const string | ProcessHelpListProcesses
const string | ProcessHelpListApplications
const string | ProcessHelpListApplicationsByWindow
const string | ProcessHelpKillProcesses
const string | ProcessHelpKillApplications
const string | ProcessHelpKillApplicationsByWindow
bool | _appProcessCommandsInitialized = false
List< string > | AppDataStructuresNames = new List<string>()
| List of installed data structure - related demo command names. More...
List< string > | AppDataStructuresHelpStrings = new List<string>()
| List of help strings corresponding to the installed data structure - related demo commands. More...
List< CommandMethod > | AppDataStructuresMethods = new List<CommandMethod>()
| List of methods used to perform data structure - related demo commmands. More...
bool | _appDataStructuresCommandsInitialized = false
Protected Attributes inherited from IG.Lib.LoadableScriptBase
string | _embeddedCommandName = null
int | _outputLevel = DefaultOutputLevel
ICommandLineApplicationInterpreter | _script_interpreter

## Private Attributes
const string | FileHelpTestArguments = FileTestArguments + " arg1 arg2 ... : Prints out the arguments of the command."

## Additional Inherited Members
Properties inherited from IG.Script.ScriptAppBase
virtual bool | IsAddRunFileByScriptCommand`[get, set]`
| Whether or not the Run command is installed on the script's interpreter. More...
Properties inherited from IG.Lib.LoadableScriptBase
string | EmbeddedCommandName`[get, set]`
| Command that was used to launch the current embedded application script. More...
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
string[] | InitializationArguments`[get, set]`
| Arguments used by the initialization method. WARNING: arguments can only be set before initialization is performed. Initialization is performed either implicitly at the first call to the Run method or explicitly by calling the Initialize method. More...
virtual bool | IsInitialized`[get, protected set]`
| Whether the object has been initialized or not. More...
static int | DefaultOutputLevel`[get, set]`
int | OutputLevel`[get, set]`
| Level of output to console produced by some operations of the current object. More...
virtual ICommandLineApplicationInterpreter | Script_Interpreter`[get, protected set]`
| Script's internal interpreter that takes care for execution of installed internal commands. More...
SortedList< string, string > | Script_CommandHelpStrings`[get]`
| Contains help strings associated with script commands installed on interpreter. More...
Properties inherited from IG.Lib.ILoadableScript
string | EmbeddedCommandName`[get, set]`
| Command that was used to launch the current embedded application script. More...
string[] | InitializationArguments`[get, set]`
| Arguments used by the initialization method. More...
bool | IsInitialized`[get]`
| Whether the object has been initialized or not. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`

## Detailed Description

Base cls. for application scripts that can also be used on its own.

The cls.es derived from this cls. are usually used as internal scripts and provide a set of embedded utiliy applications within an application that is based on an command-line interpreter.

Applications will typically extend this cls. by their own specific cls. that is used in its place for providing various embedded utility applications. The base library itself provides the AppBase cls. derived from this cls., which is used because its shorter name. See that cls. for an example how to prepare a derived cls. that will provide as set of embedded applications.

In applications that have the command-line interpreter, embedded applications from this cls. can typically be run in the following way:

AppName Internal IG.Script.AppBase CommandName arg1 arg2 ...

where AppName is the application name, IG.Script.AppBase is the full name of the script cls. that contains embedded applications, CommandName is name of the command thar launches embedded application, and arg1, arg2, etc. are command arguments for the embedded application.

See also
  ScriptAppBase

$A Igor xx May09 Jun15;

## Constructor & Destructor Documentation

IG.Script.AppBase.AppBase | ( |  | ) |
| inline

## Member Function Documentation

override void IG.Script.AppBase.Script_AddCommands | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  |
| inline virtual

Adds commands to the internal interpreter.

Reimplemented from IG.Lib.LoadableScriptBase.

Reimplemented in IG.Script.AppExtBase.

override void IG.Script.AppBase.InitAppFile | ( |  | ) |
| inline protected virtual

Initializes commands for file system related utilities (embedded applications).

Reimplemented from IG.Script.ScriptAppBase.

virtual string IG.Script.AppBase.FileFunctionTestArguments | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application that just prints arguments passed to the application to a console.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

void IG.Script.AppBase.AddCustomCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new file system - related embedded application's command (added as sub-command of the base command named ScriptAppBase.ConstFile).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.AppBase.CustomFunctionPrintArguments | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

virtual void IG.Script.AppBase.InitAppCustom | ( |  | ) |
| inline protected virtual

Initializes commands for file system related utilities (embedded applications).

virtual string IG.Script.AppBase.RunAppCustom | ( | string[] | args | ) |
| inline protected virtual

Runs a file system related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.AppBase.AppCustom | ( | string[] | arguments | ) |
| inline virtual

Runs one of the custom embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

## Member Data Documentation

const string IG.Script.AppBase.ConstCustom = "Custom"

Name of the command for a group of custom applications.

const string IG.Script.AppBase.ConstHelpCustom = "Custom application group."

const string IG.Script.AppBase.FileTestArguments = "PrintArguments"

const string IG.Script.AppBase.FileHelpTestArguments = FileTestArguments + " arg1 arg2 ... : Prints out the arguments of the command."
| private

List<string> IG.Script.AppBase.AppCustomNames = new List<string>()
| protected

List of installed file command names.

List<string> IG.Script.AppBase.AppCustomHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed file commands.

List<CommandMethod> IG.Script.AppBase.AppCustomMethods = new List<CommandMethod>()
| protected

List of methods used to perform file commmands.

const string IG.Script.AppBase.CustomPrintArguments = "PrintArguments"

const string IG.Script.AppBase.CustomHelpPrintArguments = CustomPrintArguments + " arg1 arg2 ... : Prints out the arguments of the command."
| protected

bool IG.Script.AppBase._appCustomCommandsInitialized = false
| protected

The documentation for this class was generated from the following file:

- igbase/interpreters/scriptloader/scripts/ScriptAppBase.cs